
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_BEEP_CHANNEL_H
#define PG_BEEP_CHANNEL_H

class RawBeepMsg;

// maintains counter for BEEP channels
// mod arithmetic is not yet supported
class BeepChannel {
	public:
		BeepChannel(int anId = -1);

		int id() const { return theId; }

		int nextMsgNo();
		int nextSeqNo();

		void addedMsg(const RawBeepMsg &msg);
		bool consumedMsg(const RawBeepMsg &msg);

	protected:
		int theId;
		int theNextMsgNo;
		int theNextSeqNo;
		int theExpMsgNo;  // expected
		int theExpSeqNo;
};

#endif
