
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CLIENT_APPLICATION_H
#define PG_CLIENT_APPLICATION_H

#include "app/PolyApp.h"

class WssFreezer;

class PolyClt: public PolyApp {
	public:
		typedef Array<Client*> Clients;

	public:
		PolyClt();

	protected:
		virtual void configure();
		virtual void reportCfg();

		virtual void startAgents();
		virtual void startServices();
		virtual void step();
		virtual void getOpts(Array<OptGrp*> &opts);
		virtual void makeAgent(const AgentSym &agent, const NetAddr &address);
		virtual void logState(OLog &log);

		virtual const String sideName() const;
		virtual int logCat() const;

		virtual void noteInfoEvent(BcastChannel *ch, InfoEvent ev);
		virtual void noteClientEvent(BcastChannel *ch, const Client *c);

		void startClients(int count);
		void stopClients(int count);
		Client *flipCltState(Clients &from, Clients &to);

	protected:
		Clients thePopulus;   // active clients
		Clients theAvailClts; // other clients
		WssFreezer *TheWssFreezer;
};

#endif
