
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CONTENT_MANAGER_H
#define PG_CONTENT_MANAGER_H

#include "xstd/Array.h"

class ContentCfg;
class ContentSym;

// aggregates information about content descriptions
// prevents creation of large number of identical descriptions

class ContentMgr {
	public:
		ContentMgr();
		~ContentMgr();

		bool validId(int id) const;

		ContentCfg *get(const ContentSym *cs);
		ContentCfg *get(int id);
		void get(const Array<ContentSym*> &syms, Array<ContentCfg*> &cfgs);

		ContentCfg *operator [](int id) { return get(id); }
		
	protected:
		Array<ContentCfg*> theCfgs;
		Array<ContentSym*> theSyms; // kept to search for new symbols
};

extern ContentMgr TheContentMgr;

#endif
