
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "csm/ContentCfg.h"
#include "csm/ContentTypeIdx.h"


void ContentTypeIdx::configure(const Array<ContentCfg*> &ccfgs) {
	theTids.stretch(ccfgs.count());
	for (int i = 0; i < ccfgs.count(); ++i)
		theTids.append(ccfgs[i]->id());
}

bool ContentTypeIdx::hasContType(int tid) const {
	for (int i = 0; i < theTids.count(); ++i) {
		if (theTids[i] == tid)
			return true;
	}
	return false;
}
