
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_DNS_RESPONSE_MESSAGE_H
#define PG_DNS_RESPONSE_MESSAGE_H

#include "xstd/Array.h"
#include "dns/DnsMsg.h"

class Socket;
class IBStream;

// common type for all DNS messages
class DnsResp: public DnsMsg {
	public:
		typedef Array<NetAddr*> Answers;

	public:
		DnsResp();

		void reset();

		bool recv(Socket &s);

		const Answers &answers() const { return theAnswers; }
		const Error &error() const { return theError; }

	protected:
		bool parseResp();
		bool parseName(IBStream &is, String &name);
		bool parseName(Size &off, String &name);

		void interpretRCode(Field rCode);

	protected:
		Answers theAnswers;
		Error theError;

	private: /* temporary info for parsing */
		const char *theBuf;
		int theBufSize;
};

#endif
