
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"
#include "logextractors/LogIter.h"

LogIter::LogIter(ILog *aLog): theLog(0) {
	if (aLog)
		start(aLog);
}

LogIter &LogIter::start(ILog *aLog) {
	theLog = aLog;
	thePx = LogEntryPx();
	sync();
	return *this;
}

bool LogIter::eof() const {
	return !theLog || !*theLog || !thePx;
}

LogIter::operator void *() const {
	return !eof() ? (void*)(-1) : 0;
}

LogIter &LogIter::operator ++() {
	Assert(theLog);
	theLog->endEntry();
	sync();
	return *this;
}

const LogEntryPx &LogIter::operator *() {
	Assert(!eof());
	return thePx;
}

void LogIter::sync() {
	thePx = theLog->begEntry();
	if (eof())
		thePx = LogEntryPx();
}
