
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_POP_DISTRIBUTION_SYMBOL_H
#define PGL_POP_DISTRIBUTION_SYMBOL_H

#include "pgl/PglExprSym.h"

class ostream;
class String;
class PopDistr;

// popularity distribution
class PopDistrSym: public ExpressionSym {
	public:
		PopDistrSym(const String &aType, PopDistr *aVal);
		virtual ~PopDistrSym();

		virtual bool isA(const String &type) const;

		PopDistr *val() const { return theVal; }

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

	protected:
		PopDistr *theVal;
};

#endif
