
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_SESSION_SYMBOL_H
#define PGL_SESSION_SYMBOL_H

#include "pgl/PglRecSym.h"

class Time;
class RndDistr;
class GoalSym;

// base class for robot and server symbols
class SessionSym: public RecSym {
	public:
		SessionSym();
		SessionSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		GoalSym *busyPeriod() const;
		RndDistr *idlePeriodDuration() const;
		bool heartbeatGap(Time &gap) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
