
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/h/iostream.h"
#include "xstd/h/iomanip.h"

#include "xstd/Clock.h"
#include "runtime/BcastChannel.h"

bool BcastChannel::Debug = false;

BcastChannel::BcastChannel(const String &anName): theName(anName) {
}

void BcastChannel::subscribe(BcastRcver* rcver) {
	int idx;
	if (!find(rcver, idx))
		append(rcver);
}

void BcastChannel::unsubscribe(BcastRcver* rcver) {
	int idx;
	if (find(rcver, idx)) {
		// move to the tail and pop
		swap(idx, count()-1);
		pop();
	}
}

void BcastChannel::showEvent() const {
	clog << TheClock << " event: " << theName << " x " << theCount << endl;
}
