
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_HTTP_DATE_H
#define PG_HTTP_DATE_H

class ostream;

// all HTTP date routines follow HTTP/1.1 date format requirements

extern Time HttpDateParse(const char *date, int len);
extern ostream &HttpDatePrint(ostream &os, Time date);

// prints (possibly cached) curent time
extern ostream &HttpDatePrint(ostream &os);

// all HTTP date calculations must use rounded-to-the-sec timestamps
inline
Time HttpDateAtLeast(const Time &precise) {
	return Time::Sec(precise.sec() + (precise.msec() > 0));
}

inline
Time HttpDateAtMost(const Time &precise) {
	return Time::Sec(precise.sec());
}

#endif
