
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_TRANSACTIONJ_ABORT_COORDINATES_H
#define PG_TRANSACTIONJ_ABORT_COORDINATES_H

#include "xstd/Size.h"

class RndGen;

// info required to compute whether and where to abort a transaction
class XactAbortCoord {
	public:
		XactAbortCoord();

		void configure(const RndGen &whether, const RndGen &where);
		void configure(int whether, int where);
		void reset();

		operator void*() const { return
			theWhetherState && theWhereState ? (void*)-1 : 0; }

		// negative if no abort
		Size pos(Size hdrSize, Size bodySize) const;

		int whether() const { return theWhetherState; }
		int where() const { return theWhereState; }

	protected:
		int theWhetherState;
		int theWhereState;
};

#endif
